> For the complete documentation index, see [llms.txt](https://docs.payments.thalescloud.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.payments.thalescloud.io/merchant-tokenization/visa-ctf-and-daf/implement-ctf-and-daf/synchronize-binding.md).

# Synchronize binding

Use `syncBindingState` to reconcile the **device binding** state between the Thales SDK and the Thales backend.

Call this when you suspect the SDK state is stale. This can happen after network errors, app reinstall, or interrupted device binding.

### SDK integration

Call `syncBindingState` and handle the result in the success or error callback.

{% tabs %}
{% tab title="Android" %}
{% hint style="warning" %}
This call is asynchronous.

Invoke the `runOnUiThread(Runnable)` callback when you need to update the UI.
{% endhint %}

```java
visaCTFHelper.syncBindingState(correlationId, 
                               vProvisionTokenId, 
                               new SyncBindingStateListener() {
            @Override
            public void onError(TMGClientException exception) { 
                // Handle error
            }

            @Override
            public void onSuccess(BindingState bindingState) {
                // Use bindingState to choose the next flow.
            }
        });
```

The SDK returns the current binding state in `onSuccess`, or an error in `onError`.
{% endtab %}

{% tab title="iOS" %}
{% hint style="warning" %}
This call is asynchronous.

Invoke the `DispatchQueue.main.async` callback when you need to update the UI.
{% endhint %}

```swift
let vProvisionedTokenID: String = ""
let correlationID: String = ""

// Start sync binding state
visaCTFHelper.syncBindingState(forVProvisionedTokenID: vProvisionedTokenID,
                                correlationID: correlationID) { (state, error) in
    if error == nil {
        // Use state to choose the next flow.
    } else {
        // Handle error
    } 
}
```

{% endtab %}
{% endtabs %}

### Next steps

Use the returned `BindingState` to continue with the right flow:

* `UNBOUND`: Start device binding. See [Create device binding (green flow)](/merchant-tokenization/visa-ctf-and-daf/implement-ctf-and-daf/create-device-binding-green-flow.md).
* `PENDING_ACTIVATION`: Resume device binding. This typically means the issuer required **step-up authentication** using an **ID\&V** method. See [Create device binding (yellow flow)](/merchant-tokenization/visa-ctf-and-daf/implement-ctf-and-daf/create-device-binding-yellow-flow.md).
* `BOUND`: Authenticate transactions. See [Authenticate a transaction](/merchant-tokenization/visa-ctf-and-daf/implement-ctf-and-daf/authenticate-a-transaction.md).


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.payments.thalescloud.io/merchant-tokenization/visa-ctf-and-daf/implement-ctf-and-daf/synchronize-binding.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
